Stack = {}

function Stack.new(maxSize)
	return { first = 0, last = -1, maxSize = maxSize, iterator = nil }
end

function Stack.isEmpty(t)
	if t.last == -1 or not t[t.first] then return true end
	return false
end

-- Add an element to the back of the stack.
function Stack.push(t, v)
	local last = t.last + 1
	if t.maxSize and last == t.maxSize then last = 0 end
	if t.last ~= -1 and t.first == last then
		t.first = t.first + 1
		if t.maxSize and t.first == t.maxSize then t.first = 0 end
	end
	t.last = last
	t[last] = v
end

-- Remove an element from the front of the stack.
function Stack.pop(t)
	if Stack.isEmpty(t) then return nil end
	local v = t[t.first]
	t[t.first] = nil
	t.first = t.first + 1
	if t.maxSize and t.first == t.maxSize then t.first = 0 end
	return v
end

-- View the front element of the stack without removing it.
function Stack.front(t)
	if Stack.isEmpty(t) then return nil end
	return t[t.first]
end

-- View the back element of the stack without removing it.
function Stack.back(t)
	if Stack.isEmpty(t) then return nil end
	return t[t.last]
end

function Stack.iterator(t)
	if Stack.isEmpty(t) then t.iterator = nil return end
	t.iterator = t.first
end

function Stack.next(t)
	if Stack.isEmpty(t) or not t.iterator or not t[t.iterator] then return nil end
	local v = t[t.iterator]
	if t.iterator == t.last then
		t.iterator = nil
		return v
	end
	t.iterator = t.iterator + 1
	if t.maxSize and t.iterator == t.maxSize then t.iterator = 0 end
	return v
end
